diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index 8b3602a..b329276 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -1,12 +1,14 @@
 use crate::syntax::atom::Atom::{self, *};
+use crate::syntax::mangled::ToMangled;
 use crate::syntax::namespace::Namespace;
 use crate::syntax::symbol::Symbol;
+use crate::syntax::typename::ToTypename;
 use crate::syntax::{
     self, check, mangle, Api, ExternFn, ExternType, Signature, Struct, Type, Types,
 };
 use proc_macro2::{Ident, Span, TokenStream};
 use quote::{format_ident, quote, quote_spanned, ToTokens};
-use syn::{parse_quote, Error, ItemMod, Result, Token};
+use syn::{parse_quote, spanned::Spanned, Error, ItemMod, Result, Token};
 
 pub fn bridge(namespace: &Namespace, ffi: ItemMod) -> Result<TokenStream> {
     let ident = &ffi.ident;
@@ -22,6 +24,38 @@ pub fn bridge(namespace: &Namespace, ffi: ItemMod) -> Result<TokenStream> {
     let mut hidden = TokenStream::new();
     let mut has_rust_type = false;
 
+    // "Header" to define newtypes locally so we can implement
+    // traits on them.
+    expanded.extend(quote! {
+        pub struct Vector<T>(pub ::cxx::RealVector<T>);
+        impl<T: cxx::private::VectorTarget<T>> Vector<T> {
+            pub fn size(&self) -> usize {
+                self.0.size()
+            }
+            pub fn get(&self, pos: usize) -> Option<&T> {
+                self.0.get(pos)
+            }
+            pub fn get_unchecked(&self, pos: usize) -> &T {
+                self.0.get_unchecked(pos)
+            }
+            pub fn is_empty(&self) -> bool {
+                self.0.is_empty()
+            }
+            pub fn push_back(&mut self, item: &T) {
+                self.0.push_back(item)
+            }
+        }
+        impl<'a, T: cxx::private::VectorTarget<T>> IntoIterator for &'a Vector<T> {
+            type Item = &'a T;
+            type IntoIter = <&'a ::cxx::RealVector<T> as IntoIterator>::IntoIter;
+
+            fn into_iter(self) -> Self::IntoIter {
+                self.0.into_iter()
+            }
+        }
+        unsafe impl<T> Send for Vector<T> where T: Send + cxx::private::VectorTarget<T> {}
+    });
+
     for api in &apis {
         if let Api::RustType(ety) = api {
             expanded.extend(expand_rust_type(ety));
@@ -58,10 +92,34 @@ pub fn bridge(namespace: &Namespace, ffi: ItemMod) -> Result<TokenStream> {
                     hidden.extend(expand_rust_box(namespace, ident));
                 }
             }
+        } else if let Type::RustVec(ty) = ty {
+            if let Type::Ident(ident) = &ty.inner {
+                hidden.extend(expand_rust_vec(namespace, &ty.inner, ident));
+            }
         } else if let Type::UniquePtr(ptr) = ty {
             if let Type::Ident(ident) = &ptr.inner {
                 if Atom::from(ident).is_none() {
-                    expanded.extend(expand_unique_ptr(namespace, ident, types));
+                    expanded.extend(expand_unique_ptr(namespace, &ptr.inner, types));
+                }
+            } else if let Type::Vector(_) = &ptr.inner {
+                // Generate code for unique_ptr<vector<T>> if T is not an atom
+                // or if T is a primitive.
+                // Code for primitives is already generated
+                match Atom::from(ident) {
+                    None => expanded.extend(expand_unique_ptr(namespace, &ptr.inner, types)),
+                    Some(atom) => {
+                        if atom.is_valid_vector_target() {
+                            expanded.extend(expand_unique_ptr(namespace, &ptr.inner, types));
+                        }
+                    }
+                }
+            }
+        } else if let Type::Vector(ptr) = ty {
+            if let Type::Ident(ident) = &ptr.inner {
+                if Atom::from(ident).is_none() {
+                    // Generate code for Vector<T> if T is not an atom
+                    // Code for atoms is already generated
+                    expanded.extend(expand_vector(namespace, &ptr.inner));
                 }
             }
         }
@@ -197,10 +255,12 @@ fn expand_cxx_function_shim(namespace: &Namespace, efn: &ExternFn, types: &Types
             }
             Type::RustBox(_) => quote!(::std::boxed::Box::into_raw(#var)),
             Type::UniquePtr(_) => quote!(::cxx::UniquePtr::into_raw(#var)),
+            Type::RustVec(_) => quote!(::cxx::RustVec::from(#var)),
             Type::Ref(ty) => match &ty.inner {
                 Type::Ident(ident) if ident == RustString => {
                     quote!(::cxx::private::RustString::from_ref(#var))
                 }
+                Type::RustVec(_) => quote!(::cxx::RustVec::from_ref(#var)),
                 _ => quote!(#var),
             },
             Type::Str(_) => quote!(::cxx::private::RustStr::from(#var)),
@@ -523,9 +583,42 @@ fn expand_rust_box(namespace: &Namespace, ident: &Ident) -> TokenStream {
     }
 }
 
-fn expand_unique_ptr(namespace: &Namespace, ident: &Ident, types: &Types) -> TokenStream {
-    let name = ident.to_string();
-    let prefix = format!("cxxbridge02$unique_ptr${}{}$", namespace, ident);
+fn expand_rust_vec(namespace: &Namespace, ty: &Type, ident: &Ident) -> TokenStream {
+    let inner = ty;
+    let mangled = ty.to_mangled(&namespace.segments) + "$";
+    let link_prefix = format!("cxxbridge02$rust_vec${}", mangled);
+    let link_drop = format!("{}drop", link_prefix);
+    let link_vector_from = format!("{}vector_from", link_prefix);
+    let link_len = format!("{}len", link_prefix);
+
+    let local_prefix = format_ident!("{}__vec_", ident);
+    let local_drop = format_ident!("{}drop", local_prefix);
+    let local_vector_from = format_ident!("{}vector_from", local_prefix);
+    let local_len = format_ident!("{}len", local_prefix);
+
+    let span = ty.span();
+    quote_spanned! {span=>
+        #[doc(hidden)]
+        #[export_name = #link_drop]
+        unsafe extern "C" fn #local_drop(this: *mut ::cxx::RustVec<#inner>) {
+            std::ptr::drop_in_place(this);
+        }
+        #[export_name = #link_vector_from]
+        unsafe extern "C" fn #local_vector_from(this: *mut ::cxx::RustVec<#inner>, vector: *mut ::cxx::RealVector<#inner>) {
+            this.as_ref().unwrap().into_vector(vector.as_mut().unwrap());
+        }
+        #[export_name = #link_len]
+        unsafe extern "C" fn #local_len(this: *const ::cxx::RustVec<#inner>) -> usize {
+            this.as_ref().unwrap().len()
+        }
+    }
+}
+
+fn expand_unique_ptr(namespace: &Namespace, ty: &Type, types: &Types) -> TokenStream {
+    let name = ty.to_typename(&namespace.segments);
+    let inner = ty;
+    let mangled = ty.to_mangled(&namespace.segments) + "$";
+    let prefix = format!("cxxbridge02$unique_ptr${}", mangled);
     let link_null = format!("{}null", prefix);
     let link_new = format!("{}new", prefix);
     let link_raw = format!("{}raw", prefix);
@@ -533,8 +626,8 @@ fn expand_unique_ptr(namespace: &Namespace, ident: &Ident, types: &Types) -> Tok
     let link_release = format!("{}release", prefix);
     let link_drop = format!("{}drop", prefix);
 
-    let new_method = if types.structs.contains_key(ident) {
-        Some(quote! {
+    let new_method = match ty {
+        Type::Ident(ident) if types.structs.contains_key(ident) => Some(quote! {
             fn __new(mut value: Self) -> *mut ::std::ffi::c_void {
                 extern "C" {
                     #[link_name = #link_new]
@@ -544,13 +637,12 @@ fn expand_unique_ptr(namespace: &Namespace, ident: &Ident, types: &Types) -> Tok
                 unsafe { __new(&mut repr, &mut value) }
                 repr
             }
-        })
-    } else {
-        None
+        }),
+        _ => None,
     };
 
     quote! {
-        unsafe impl ::cxx::private::UniquePtrTarget for #ident {
+        unsafe impl ::cxx::private::UniquePtrTarget for #inner {
             const __NAME: &'static str = #name;
             fn __null() -> *mut ::std::ffi::c_void {
                 extern "C" {
@@ -565,7 +657,7 @@ fn expand_unique_ptr(namespace: &Namespace, ident: &Ident, types: &Types) -> Tok
             unsafe fn __raw(raw: *mut Self) -> *mut ::std::ffi::c_void {
                 extern "C" {
                     #[link_name = #link_raw]
-                    fn __raw(this: *mut *mut ::std::ffi::c_void, raw: *mut #ident);
+                    fn __raw(this: *mut *mut ::std::ffi::c_void, raw: *mut #inner);
                 }
                 let mut repr = ::std::ptr::null_mut::<::std::ffi::c_void>();
                 __raw(&mut repr, raw);
@@ -574,14 +666,14 @@ fn expand_unique_ptr(namespace: &Namespace, ident: &Ident, types: &Types) -> Tok
             unsafe fn __get(repr: *mut ::std::ffi::c_void) -> *const Self {
                 extern "C" {
                     #[link_name = #link_get]
-                    fn __get(this: *const *mut ::std::ffi::c_void) -> *const #ident;
+                    fn __get(this: *const *mut ::std::ffi::c_void) -> *const #inner;
                 }
                 __get(&repr)
             }
             unsafe fn __release(mut repr: *mut ::std::ffi::c_void) -> *mut Self {
                 extern "C" {
                     #[link_name = #link_release]
-                    fn __release(this: *mut *mut ::std::ffi::c_void) -> *mut #ident;
+                    fn __release(this: *mut *mut ::std::ffi::c_void) -> *mut #inner;
                 }
                 __release(&mut repr)
             }
@@ -596,6 +688,90 @@ fn expand_unique_ptr(namespace: &Namespace, ident: &Ident, types: &Types) -> Tok
     }
 }
 
+fn expand_vector(namespace: &Namespace, ty: &Type) -> TokenStream {
+    let inner = ty;
+    let mangled = ty.to_mangled(&namespace.segments) + "$";
+    let prefix = format!("cxxbridge02$std$vector${}", mangled);
+    let link_length = format!("{}length", prefix);
+    let link_get_unchecked = format!("{}get_unchecked", prefix);
+    let link_push_back = format!("{}push_back", prefix);
+
+    quote! {
+        impl ::cxx::private::VectorTarget<#inner> for #inner {
+            fn get_unchecked(v: &::cxx::RealVector<#inner>, pos: usize) -> &#inner {
+                extern "C" {
+                    #[link_name = #link_get_unchecked]
+                    fn __get_unchecked(_: &::cxx::RealVector<#inner>, _: usize) -> &#inner;
+                }
+                unsafe {
+                    __get_unchecked(v, pos)
+                }
+            }
+            fn vector_length(v: &::cxx::RealVector<#inner>) -> usize {
+                unsafe {
+                    extern "C" {
+                        #[link_name = #link_length]
+                        fn __vector_length(_: &::cxx::RealVector<#inner>) -> usize;
+                    }
+                    __vector_length(v)
+                }
+            }
+            fn push_back(v: &::cxx::RealVector<#inner>, item: &#inner) {
+                unsafe {
+                    extern "C" {
+                        #[link_name = #link_push_back]
+                        fn __push_back(_: &::cxx::RealVector<#inner>, _: &#inner) -> usize;
+                    }
+                    __push_back(v, item);
+                }
+            }
+        }
+    }
+}
+
+pub fn expand_vector_builtin(ident: Ident) -> TokenStream {
+    let ty = Type::Ident(ident);
+    let inner = &ty;
+    let namespace = Namespace { segments: vec![] };
+    let mangled = ty.to_mangled(&namespace.segments) + "$";
+    let prefix = format!("cxxbridge02$std$vector${}", mangled);
+    let link_length = format!("{}length", prefix);
+    let link_get_unchecked = format!("{}get_unchecked", prefix);
+    let link_push_back = format!("{}push_back", prefix);
+
+    quote! {
+        impl VectorTarget<#inner> for #inner {
+            fn get_unchecked(v: &RealVector<#inner>, pos: usize) -> &#inner {
+                extern "C" {
+                    #[link_name = #link_get_unchecked]
+                    fn __get_unchecked(_: &RealVector<#inner>, _: usize) -> &#inner;
+                }
+                unsafe {
+                    __get_unchecked(v, pos)
+                }
+            }
+            fn vector_length(v: &RealVector<#inner>) -> usize {
+                unsafe {
+                    extern "C" {
+                        #[link_name = #link_length]
+                        fn __vector_length(_: &RealVector<#inner>) -> usize;
+                    }
+                    __vector_length(v)
+                }
+            }
+            fn push_back(v: &RealVector<#inner>, item: &#inner) {
+                unsafe {
+                    extern "C" {
+                        #[link_name = #link_push_back]
+                        fn __push_back(_: &RealVector<#inner>, _: &#inner) -> usize;
+                    }
+                    __push_back(v, item);
+                }
+            }
+        }
+    }
+}
+
 fn expand_return_type(ret: &Option<Type>) -> TokenStream {
     match ret {
         Some(ret) => quote!(-> #ret),
@@ -613,11 +789,16 @@ fn expand_extern_type(ty: &Type) -> TokenStream {
     match ty {
         Type::Ident(ident) if ident == RustString => quote!(::cxx::private::RustString),
         Type::RustBox(ty) | Type::UniquePtr(ty) => {
-            let inner = &ty.inner;
+            let inner = expand_extern_type(&ty.inner);
             quote!(*mut #inner)
         }
+        Type::RustVec(ty) => quote!(::cxx::RustVec<#ty>),
         Type::Ref(ty) => match &ty.inner {
             Type::Ident(ident) if ident == RustString => quote!(&::cxx::private::RustString),
+            Type::RustVec(ty) => {
+                let inner = expand_extern_type(&ty.inner);
+                quote!(&::cxx::RustVec<#inner>)
+            }
             _ => quote!(#ty),
         },
         Type::Str(_) => quote!(::cxx::private::RustStr),
diff --git a/macro/src/lib.rs b/macro/src/lib.rs
index b56f58e..87fe405 100644
--- a/macro/src/lib.rs
+++ b/macro/src/lib.rs
@@ -14,7 +14,7 @@ mod syntax;
 
 use crate::syntax::namespace::Namespace;
 use proc_macro::TokenStream;
-use syn::{parse_macro_input, ItemMod};
+use syn::{parse_macro_input, Ident, ItemMod};
 
 /// `#[cxx::bridge] mod ffi { ... }`
 ///
@@ -44,3 +44,9 @@ pub fn bridge(args: TokenStream, input: TokenStream) -> TokenStream {
         .unwrap_or_else(|err| err.to_compile_error())
         .into()
 }
+
+#[proc_macro]
+pub fn vector_builtin(input: TokenStream) -> TokenStream {
+    let ident = parse_macro_input!(input as Ident);
+    expand::expand_vector_builtin(ident).into()
+}
diff --git a/src/cxx.cc b/src/cxx.cc
index b64333c..916f525 100644
--- a/src/cxx.cc
+++ b/src/cxx.cc
@@ -3,6 +3,7 @@
 #include <exception>
 #include <iostream>
 #include <memory>
+#include <vector>
 #include <stdexcept>
 
 template <typename Exception>
@@ -197,3 +198,50 @@ void cxxbridge02$unique_ptr$std$string$drop(
   ptr->~unique_ptr();
 }
 } // extern "C"
+
+#define STD_VECTOR_OPS(RUST_TYPE, CXX_TYPE) \
+extern "C" { \
+size_t cxxbridge02$std$vector$##RUST_TYPE##$length(const std::vector<CXX_TYPE> &s) noexcept { \
+  return s.size(); \
+} \
+void cxxbridge02$std$vector$##RUST_TYPE##$push_back(std::vector<CXX_TYPE> &s, const CXX_TYPE &item) noexcept { \
+  s.push_back(item); \
+} \
+const CXX_TYPE *cxxbridge02$std$vector$##RUST_TYPE##$get_unchecked(const std::vector<CXX_TYPE> &s, size_t pos) noexcept { \
+  return &s[pos]; \
+} \
+static_assert(sizeof(::std::unique_ptr<std::vector<CXX_TYPE>>) == sizeof(void *), ""); \
+static_assert(alignof(::std::unique_ptr<std::vector<CXX_TYPE>>) == alignof(void *), ""); \
+void cxxbridge02$unique_ptr$std$vector$##RUST_TYPE##$null(::std::unique_ptr<std::vector<CXX_TYPE>> *ptr) noexcept { \
+  new (ptr) ::std::unique_ptr<std::vector<CXX_TYPE>>(); \
+} \
+void cxxbridge02$unique_ptr$std$vector$##RUST_TYPE##$new(::std::unique_ptr<std::vector<CXX_TYPE>> *ptr, std::vector<CXX_TYPE> *value) noexcept { \
+  new (ptr) ::std::unique_ptr<std::vector<CXX_TYPE>>(new std::vector<CXX_TYPE>(::std::move(*value))); \
+} \
+void cxxbridge02$unique_ptr$std$vector$##RUST_TYPE##$raw(::std::unique_ptr<std::vector<CXX_TYPE>> *ptr, std::vector<CXX_TYPE> *raw) noexcept { \
+  new (ptr) ::std::unique_ptr<std::vector<CXX_TYPE>>(raw); \
+} \
+const std::vector<CXX_TYPE> *cxxbridge02$unique_ptr$std$vector$##RUST_TYPE##$get(const ::std::unique_ptr<std::vector<CXX_TYPE>>& ptr) noexcept { \
+  return ptr.get(); \
+} \
+std::vector<CXX_TYPE> *cxxbridge02$unique_ptr$std$vector$##RUST_TYPE##$release(::std::unique_ptr<std::vector<CXX_TYPE>>& ptr) noexcept { \
+  return ptr.release(); \
+} \
+void cxxbridge02$unique_ptr$std$vector$##RUST_TYPE##$drop(::std::unique_ptr<std::vector<CXX_TYPE>> *ptr) noexcept { \
+  ptr->~unique_ptr(); \
+} \
+} // extern "C"
+
+STD_VECTOR_OPS(u8, uint8_t);
+STD_VECTOR_OPS(u16, uint16_t);
+STD_VECTOR_OPS(u32, uint32_t);
+STD_VECTOR_OPS(u64, uint64_t);
+STD_VECTOR_OPS(usize, size_t);
+STD_VECTOR_OPS(i8, int8_t);
+STD_VECTOR_OPS(i16, int16_t);
+STD_VECTOR_OPS(i32, int32_t);
+STD_VECTOR_OPS(i64, int64_t);
+STD_VECTOR_OPS(isize, rust::isize);
+STD_VECTOR_OPS(f32, float);
+STD_VECTOR_OPS(f64, double);
+
diff --git a/src/lib.rs b/src/lib.rs
index 74e103a..994c430 100644
--- a/src/lib.rs
+++ b/src/lib.rs
@@ -370,13 +370,18 @@ mod result;
 mod rust_sliceu8;
 mod rust_str;
 mod rust_string;
+mod rust_vec;
 mod syntax;
 mod unique_ptr;
 mod unwind;
+mod vector;
 
 pub use crate::cxx_string::CxxString;
 pub use crate::exception::Exception;
+pub use crate::rust_vec::RustVec;
 pub use crate::unique_ptr::UniquePtr;
+pub use crate::vector::RealVector;
+pub use crate::vector::VectorIntoIterator;
 pub use cxxbridge_macro::bridge;
 
 // Not public API.
@@ -390,6 +395,7 @@ pub mod private {
     pub use crate::rust_string::RustString;
     pub use crate::unique_ptr::UniquePtrTarget;
     pub use crate::unwind::catch_unwind;
+    pub use crate::vector::VectorTarget;
 }
 
 use crate::error::Result;
diff --git a/src/rust_vec.rs b/src/rust_vec.rs
new file mode 100644
index 0000000..a28570d
--- /dev/null
+++ b/src/rust_vec.rs
@@ -0,0 +1,39 @@
+use crate::vector::RealVector;
+use crate::vector::VectorTarget;
+
+#[repr(C)]
+pub struct RustVec<T: VectorTarget<T>> {
+    repr: Vec<T>,
+}
+
+impl<T: VectorTarget<T>> RustVec<T> {
+    pub fn from(v: Vec<T>) -> Self {
+        RustVec { repr: v }
+    }
+
+    pub fn from_ref(v: &Vec<T>) -> &Self {
+        unsafe { std::mem::transmute::<&Vec<T>, &RustVec<T>>(v) }
+    }
+
+    pub fn into_vec(self) -> Vec<T> {
+        self.repr
+    }
+
+    pub fn as_vec(&self) -> &Vec<T> {
+        &self.repr
+    }
+
+    pub fn as_mut_vec(&mut self) -> &mut Vec<T> {
+        &mut self.repr
+    }
+
+    pub fn len(&self) -> usize {
+        self.repr.len()
+    }
+
+    pub fn into_vector(&self, vec: &mut RealVector<T>) {
+        for item in &self.repr {
+            vec.push_back(item);
+        }
+    }
+}
diff --git a/src/vector.rs b/src/vector.rs
new file mode 100644
index 0000000..805bdbb
--- /dev/null
+++ b/src/vector.rs
@@ -0,0 +1,91 @@
+pub trait VectorTarget<T> {
+    fn get_unchecked(v: &RealVector<T>, pos: usize) -> &T
+    where
+        Self: Sized;
+    fn vector_length(v: &RealVector<T>) -> usize
+    where
+        Self: Sized;
+    fn push_back(v: &RealVector<T>, item: &T)
+    where
+        Self: Sized;
+}
+
+/// Binding to C++ `std::vector`.
+///
+/// # Invariants
+///
+/// As an invariant of this API and the static analysis of the cxx::bridge
+/// macro, in Rust code we can never obtain a `Vector` by value. C++'s vector
+/// requires a move constructor and may hold internal pointers, which is not
+/// compatible with Rust's move behavior. Instead in Rust code we will only ever
+/// look at a Vector through a reference or smart pointer, as in `&Vector`
+/// or `UniquePtr<Vector>`.
+#[repr(C)]
+pub struct RealVector<T> {
+    _private: [T; 0],
+}
+
+impl<T: VectorTarget<T>> RealVector<T> {
+    /// Returns the length of the vector in bytes.
+    pub fn size(&self) -> usize {
+        T::vector_length(self)
+    }
+
+    pub fn get_unchecked(&self, pos: usize) -> &T {
+        T::get_unchecked(self, pos)
+    }
+
+    /// Returns true if `self` has a length of zero bytes.
+    pub fn is_empty(&self) -> bool {
+        self.size() == 0
+    }
+
+    pub fn get(&self, pos: usize) -> Option<&T> {
+        if pos < self.size() {
+            Some(self.get_unchecked(pos))
+        } else {
+            None
+        }
+    }
+
+    pub fn push_back(&mut self, item: &T) {
+        T::push_back(self, item);
+    }
+}
+
+unsafe impl<T> Send for RealVector<T> where T: Send + VectorTarget<T> {}
+
+pub struct VectorIntoIterator<'a, T> {
+    v: &'a RealVector<T>,
+    index: usize,
+}
+
+impl<'a, T: VectorTarget<T>> IntoIterator for &'a RealVector<T> {
+    type Item = &'a T;
+    type IntoIter = VectorIntoIterator<'a, T>;
+
+    fn into_iter(self) -> Self::IntoIter {
+        VectorIntoIterator { v: self, index: 0 }
+    }
+}
+
+impl<'a, T: VectorTarget<T>> Iterator for VectorIntoIterator<'a, T> {
+    type Item = &'a T;
+    fn next(&mut self) -> Option<Self::Item> {
+        self.index = self.index + 1;
+        self.v.get(self.index - 1)
+    }
+}
+
+cxxbridge_macro::vector_builtin!(u8);
+cxxbridge_macro::vector_builtin!(u16);
+cxxbridge_macro::vector_builtin!(u32);
+cxxbridge_macro::vector_builtin!(u64);
+cxxbridge_macro::vector_builtin!(usize);
+cxxbridge_macro::vector_builtin!(i8);
+cxxbridge_macro::vector_builtin!(i16);
+cxxbridge_macro::vector_builtin!(i32);
+cxxbridge_macro::vector_builtin!(i64);
+cxxbridge_macro::vector_builtin!(isize);
+cxxbridge_macro::vector_builtin!(f32);
+cxxbridge_macro::vector_builtin!(f64);
diff --git a/syntax/atom.rs b/syntax/atom.rs
index eeea831..c68b3fe 100644
--- a/syntax/atom.rs
+++ b/syntax/atom.rs
@@ -42,6 +42,43 @@ impl Atom {
             _ => None,
         }
     }
+
+    pub fn to_cxx(&self) -> &'static str {
+        use self::Atom::*;
+        match self {
+            Bool => "bool",
+            U8 => "uint8_t",
+            U16 => "uint16_t",
+            U32 => "uint32_t",
+            U64 => "uint64_t",
+            Usize => "size_t",
+            I8 => "int8_t",
+            I16 => "int16_t",
+            I32 => "int32_t",
+            I64 => "int64_t",
+            Isize => "::rust::isize",
+            F32 => "float",
+            F64 => "double",
+            CxxString => "::std::string",
+            RustString => "::rust::String",
+        }
+    }
+
+    pub fn is_valid_vector_target(&self) -> bool {
+        use self::Atom::*;
+        *self == U8
+            || *self == U16
+            || *self == U32
+            || *self == U64
+            || *self == Usize
+            || *self == I8
+            || *self == I16
+            || *self == I32
+            || *self == I64
+            || *self == Isize
+            || *self == F32
+            || *self == F64
+    }
 }
 
 impl PartialEq<Atom> for Ident {
diff --git a/syntax/check.rs b/syntax/check.rs
index 5e8cc09..387f9a6 100644
--- a/syntax/check.rs
+++ b/syntax/check.rs
@@ -29,7 +29,9 @@ fn do_typecheck(cx: &mut Check) {
         match ty {
             Type::Ident(ident) => check_type_ident(cx, ident),
             Type::RustBox(ptr) => check_type_box(cx, ptr),
+            Type::RustVec(ptr) => check_type_vec(cx, ptr),
             Type::UniquePtr(ptr) => check_type_unique_ptr(cx, ptr),
+            Type::Vector(ptr) => check_type_vector(cx, ptr),
             Type::Ref(ty) => check_type_ref(cx, ty),
             Type::Slice(ty) => check_type_slice(cx, ty),
             _ => {}
@@ -87,6 +89,21 @@ fn check_type_box(cx: &mut Check, ptr: &Ty1) {
     cx.error(ptr, "unsupported target type of Box");
 }
 
+fn check_type_vec(cx: &mut Check, ptr: &Ty1) {
+    // Vec can contain either user-defined type or u8
+    if let Type::Ident(ident) = &ptr.inner {
+        if Atom::from(ident).map(|a| a.is_valid_vector_target()) == Some(true) {
+            return;
+        } else if cx.types.cxx.contains(ident) {
+            cx.error(ptr, error::VEC_CXX_TYPE.msg);
+        } else {
+            return;
+        }
+    }
+
+    cx.error(ptr, "unsupported target type of Vec");
+}
+
 fn check_type_unique_ptr(cx: &mut Check, ptr: &Ty1) {
     if let Type::Ident(ident) = &ptr.inner {
         if cx.types.rust.contains(ident) {
@@ -97,11 +114,31 @@ fn check_type_unique_ptr(cx: &mut Check, ptr: &Ty1) {
             None | Some(CxxString) => return,
             _ => {}
         }
+    } else if let Type::Vector(_) = &ptr.inner {
+        return;
     }
 
     cx.error(ptr, "unsupported unique_ptr target type");
 }
 
+fn check_type_vector(cx: &mut Check, ptr: &Ty1) {
+    if let Type::Ident(ident) = &ptr.inner {
+        if cx.types.rust.contains(ident) {
+            cx.error(ptr, "vector of a Rust type is not supported yet");
+        }
+
+        match Atom::from(ident) {
+            None => return,
+            Some(atom) => {
+                if atom.is_valid_vector_target() {
+                    return;
+                }
+            }
+        }
+    }
+    cx.error(ptr, "unsupported vector target type");
+}
+
 fn check_type_ref(cx: &mut Check, ty: &Ref) {
     if ty.lifetime.is_some() {
         cx.error(ty, "references with explicit lifetimes are not supported");
@@ -310,9 +347,11 @@ fn describe(cx: &mut Check, ty: &Type) -> String {
             }
         }
         Type::RustBox(_) => "Box".to_owned(),
+        Type::RustVec(_) => "Vec".to_owned(),
         Type::UniquePtr(_) => "unique_ptr".to_owned(),
         Type::Ref(_) => "reference".to_owned(),
         Type::Str(_) => "&str".to_owned(),
+        Type::Vector(_) => "vector".to_owned(),
         Type::Slice(_) => "slice".to_owned(),
         Type::SliceRefU8(_) => "&[u8]".to_owned(),
         Type::Fn(_) => "function pointer".to_owned(),
diff --git a/syntax/error.rs b/syntax/error.rs
index f52d651..103a54f 100644
--- a/syntax/error.rs
+++ b/syntax/error.rs
@@ -15,6 +15,7 @@ impl Display for Error {
 
 pub static ERRORS: &[Error] = &[
     BOX_CXX_TYPE,
+    VEC_CXX_TYPE,
     CXXBRIDGE_RESERVED,
     CXX_STRING_BY_VALUE,
     CXX_TYPE_BY_VALUE,
@@ -29,6 +30,12 @@ pub static BOX_CXX_TYPE: Error = Error {
     note: Some("hint: use UniquePtr<>"),
 };
 
+pub static VEC_CXX_TYPE: Error = Error {
+    msg: "Vec of a C++ type is not supported yet",
+    label: None,
+    note: Some("hint: use UniquePtr<>"),
+};
+
 pub static CXXBRIDGE_RESERVED: Error = Error {
     msg: "identifiers starting with cxxbridge are reserved",
     label: Some("reserved identifier"),
diff --git a/syntax/impls.rs b/syntax/impls.rs
index a2ce05b..8e94f06 100644
--- a/syntax/impls.rs
+++ b/syntax/impls.rs
@@ -26,6 +26,8 @@ impl Hash for Type {
             Type::UniquePtr(t) => t.hash(state),
             Type::Ref(t) => t.hash(state),
             Type::Str(t) => t.hash(state),
+            Type::RustVec(t) => t.hash(state),
+            Type::Vector(t) => t.hash(state),
             Type::Fn(t) => t.hash(state),
             Type::Slice(t) => t.hash(state),
             Type::SliceRefU8(t) => t.hash(state),
@@ -44,6 +46,8 @@ impl PartialEq for Type {
             (Type::UniquePtr(lhs), Type::UniquePtr(rhs)) => lhs == rhs,
             (Type::Ref(lhs), Type::Ref(rhs)) => lhs == rhs,
             (Type::Str(lhs), Type::Str(rhs)) => lhs == rhs,
+            (Type::RustVec(lhs), Type::RustVec(rhs)) => lhs == rhs,
+            (Type::Vector(lhs), Type::Vector(rhs)) => lhs == rhs,
             (Type::Fn(lhs), Type::Fn(rhs)) => lhs == rhs,
             (Type::Slice(lhs), Type::Slice(rhs)) => lhs == rhs,
             (Type::SliceRefU8(lhs), Type::SliceRefU8(rhs)) => lhs == rhs,
diff --git a/syntax/mangled.rs b/syntax/mangled.rs
new file mode 100644
index 0000000..56e8b73
--- /dev/null
+++ b/syntax/mangled.rs
@@ -0,0 +1,30 @@
+use crate::syntax::{Atom, Type};
+
+pub trait ToMangled {
+    fn to_mangled(&self, namespace: &Vec<String>) -> String;
+}
+
+impl ToMangled for Type {
+    fn to_mangled(&self, namespace: &Vec<String>) -> String {
+        match self {
+            Type::Ident(ident) => {
+                let mut instance = String::new();
+                // Do not apply namespace to built-in type
+                let is_user_type = Atom::from(ident).is_none();
+                if is_user_type {
+                    for name in namespace {
+                        instance += name;
+                        instance += "$";
+                    }
+                }
+                instance += &ident.to_string();
+                instance
+            }
+            Type::RustBox(ptr) => format!("rust_box${}", ptr.inner.to_mangled(namespace)),
+            Type::RustVec(ptr) => format!("rust_vec${}", ptr.inner.to_mangled(namespace)),
+            Type::UniquePtr(ptr) => format!("std$unique_ptr${}", ptr.inner.to_mangled(namespace)),
+            Type::Vector(ptr) => format!("std$vector${}", ptr.inner.to_mangled(namespace)),
+            _ => unimplemented!(),
+        }
+    }
+}
diff --git a/syntax/mod.rs b/syntax/mod.rs
index ab5cecc..4e0b908 100644
--- a/syntax/mod.rs
+++ b/syntax/mod.rs
@@ -8,11 +8,13 @@ pub mod error;
 pub mod ident;
 mod impls;
 pub mod mangle;
+pub mod mangled;
 pub mod namespace;
 mod parse;
 pub mod set;
 pub mod symbol;
 mod tokens;
+pub mod typename;
 pub mod types;
 
 use self::parse::kw;
@@ -86,9 +88,11 @@ pub struct Receiver {
 pub enum Type {
     Ident(Ident),
     RustBox(Box<Ty1>),
+    RustVec(Box<Ty1>),
     UniquePtr(Box<Ty1>),
     Ref(Box<Ref>),
     Str(Box<Ref>),
+    Vector(Box<Ty1>),
     Fn(Box<Signature>),
     Void(Span),
     Slice(Box<Slice>),
diff --git a/syntax/namespace.rs b/syntax/namespace.rs
index d26bb9e..a4e972b 100644
--- a/syntax/namespace.rs
+++ b/syntax/namespace.rs
@@ -11,7 +11,7 @@ mod kw {
 
 #[derive(Clone)]
 pub struct Namespace {
-    segments: Vec<String>,
+    pub segments: Vec<String>,
 }
 
 impl Namespace {
diff --git a/syntax/parse.rs b/syntax/parse.rs
index 7d92b1b..f5c598d 100644
--- a/syntax/parse.rs
+++ b/syntax/parse.rs
@@ -300,6 +300,16 @@ fn parse_type_path(ty: &TypePath) -> Result<Type> {
                             rangle: generic.gt_token,
                         })));
                     }
+                } else if ident == "Vector" && generic.args.len() == 1 {
+                    if let GenericArgument::Type(arg) = &generic.args[0] {
+                        let inner = parse_type(arg)?;
+                        return Ok(Type::Vector(Box::new(Ty1 {
+                            name: ident,
+                            langle: generic.lt_token,
+                            inner,
+                            rangle: generic.gt_token,
+                        })));
+                    }
                 } else if ident == "Box" && generic.args.len() == 1 {
                     if let GenericArgument::Type(arg) = &generic.args[0] {
                         let inner = parse_type(arg)?;
@@ -310,6 +320,16 @@ fn parse_type_path(ty: &TypePath) -> Result<Type> {
                             rangle: generic.gt_token,
                         })));
                     }
+                } else if ident == "Vec" && generic.args.len() == 1 {
+                    if let GenericArgument::Type(arg) = &generic.args[0] {
+                        let inner = parse_type(arg)?;
+                        return Ok(Type::RustVec(Box::new(Ty1 {
+                            name: ident,
+                            langle: generic.lt_token,
+                            inner,
+                            rangle: generic.gt_token,
+                        })));
+                    }
                 }
             }
             PathArguments::Parenthesized(_) => {}
